<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.objects</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        Module&nbsp;objects
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pyxmpp.objects-module.html">Module pyxmpp.objects</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"># (C) Copyright 2003-2010 Jacek Konieczny &lt;jajcus@jajcus.net&gt;</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"># This program is free software; you can redistribute it and/or modify</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment"># it under the terms of the GNU Lesser General Public License Version</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"># 2.1 as published by the Free Software Foundation.</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"># This program is distributed in the hope that it will be useful,</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment"># but WITHOUT ANY WARRANTY; without even the implied warranty of</tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"># MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment"># GNU Lesser General Public License for more details.</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"># You should have received a copy of the GNU Lesser General Public</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"># License along with this program; if not, write to the Free Software</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"># Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"><tt class="py-comment"># pylint: disable-msg=W0232, E0201</tt> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"><tt class="py-docstring">"""General base classes for PyXMPP objects."""</tt> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"><tt class="py-name">__docformat__</tt><tt class="py-op">=</tt><tt class="py-string">"restructuredtext en"</tt> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">libxml2</tt> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-0" class="py-name" targets="Package pyxmpp=pyxmpp-module.html"><a title="pyxmpp" class="py-name" href="#" onclick="return doclink('link-0', 'pyxmpp', 'link-0');">pyxmpp</a></tt><tt class="py-op">.</tt><tt id="link-1" class="py-name" targets="Module pyxmpp.xmlextra=pyxmpp.xmlextra-module.html"><a title="pyxmpp.xmlextra" class="py-name" href="#" onclick="return doclink('link-1', 'xmlextra', 'link-1');">xmlextra</a></tt> <tt class="py-keyword">import</tt> <tt id="link-2" class="py-name" targets="Variable pyxmpp.xmlextra.common_doc=pyxmpp.xmlextra-module.html#common_doc"><a title="pyxmpp.xmlextra.common_doc" class="py-name" href="#" onclick="return doclink('link-2', 'common_doc', 'link-2');">common_doc</a></tt> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"> </tt>
<a name="StanzaPayloadObject"></a><div id="StanzaPayloadObject-def"><a name="L26"></a><tt class="py-lineno"> 26</tt> <a class="py-toggle" href="#" id="StanzaPayloadObject-toggle" onclick="return toggle('StanzaPayloadObject');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.objects.StanzaPayloadObject-class.html">StanzaPayloadObject</a><tt class="py-op">(</tt><tt class="py-base-class">object</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="StanzaPayloadObject-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="StanzaPayloadObject-expanded"><a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line">    <tt class="py-docstring">"""Base class for objects that may be used as XMPP stanza payload and don't keep</tt> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt>  <tt class="py-line"><tt class="py-docstring">    internal XML representation, only parsed values.</tt> </tt>
<a name="L29"></a><tt class="py-lineno"> 29</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line"><tt class="py-docstring">    Provides `as_xml` method. Derived classes must override `xml_element_name` and</tt> </tt>
<a name="L31"></a><tt class="py-lineno"> 31</tt>  <tt class="py-line"><tt class="py-docstring">    `xml_element_namespace` class attributes and the `complete_xml_element` method.</tt> </tt>
<a name="L32"></a><tt class="py-lineno"> 32</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line"><tt class="py-docstring">    Please note that not all classes derived from `StanzaPayloadObject` should be</tt> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line"><tt class="py-docstring">    used directly as stanza payload. Some of them are parts of higher level objects.</tt> </tt>
<a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L36"></a><tt class="py-lineno"> 36</tt>  <tt class="py-line"><tt class="py-docstring">    :Cvariables:</tt> </tt>
<a name="L37"></a><tt class="py-lineno"> 37</tt>  <tt class="py-line"><tt class="py-docstring">        - `xml_element_name`: name for the XML element provided by the class.</tt> </tt>
<a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line"><tt class="py-docstring">        - `xml_element_namespace`: namespace URI for the XML element provided</tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line"><tt class="py-docstring">          by the class.</tt> </tt>
<a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line"><tt class="py-docstring">        - `xml_element_name`: `unicode`</tt> </tt>
<a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line"><tt class="py-docstring">        - `xml_element_namespace`: `unicode`</tt> </tt>
<a name="L43"></a><tt class="py-lineno"> 43</tt>  <tt class="py-line"><tt class="py-docstring">    """</tt> </tt>
<a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line">    <tt id="link-3" class="py-name" targets="Variable pyxmpp.jabber.dataforms.Field.xml_element_name=pyxmpp.jabber.dataforms.Field-class.html#xml_element_name,Variable pyxmpp.jabber.dataforms.Form.xml_element_name=pyxmpp.jabber.dataforms.Form-class.html#xml_element_name,Variable pyxmpp.jabber.dataforms.Item.xml_element_name=pyxmpp.jabber.dataforms.Item-class.html#xml_element_name,Variable pyxmpp.jabber.dataforms.Option.xml_element_name=pyxmpp.jabber.dataforms.Option-class.html#xml_element_name,Variable pyxmpp.jabber.delay.Delay.xml_element_name=pyxmpp.jabber.delay.Delay-class.html#xml_element_name,Variable pyxmpp.jabber.register.Register.xml_element_name=pyxmpp.jabber.register.Register-class.html#xml_element_name,Variable pyxmpp.jabber.vcard.VCard.xml_element_name=pyxmpp.jabber.vcard.VCard-class.html#xml_element_name,Variable pyxmpp.objects.StanzaPayloadObject.xml_element_name=pyxmpp.objects.StanzaPayloadObject-class.html#xml_element_name,Variable pyxmpp.roster.Roster.xml_element_name=pyxmpp.roster.Roster-class.html#xml_element_name,Variable pyxmpp.roster.RosterItem.xml_element_name=pyxmpp.roster.RosterItem-class.html#xml_element_name"><a title="pyxmpp.jabber.dataforms.Field.xml_element_name
pyxmpp.jabber.dataforms.Form.xml_element_name
pyxmpp.jabber.dataforms.Item.xml_element_name
pyxmpp.jabber.dataforms.Option.xml_element_name
pyxmpp.jabber.delay.Delay.xml_element_name
pyxmpp.jabber.register.Register.xml_element_name
pyxmpp.jabber.vcard.VCard.xml_element_name
pyxmpp.objects.StanzaPayloadObject.xml_element_name
pyxmpp.roster.Roster.xml_element_name
pyxmpp.roster.RosterItem.xml_element_name" class="py-name" href="#" onclick="return doclink('link-3', 'xml_element_name', 'link-3');">xml_element_name</a></tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L45"></a><tt class="py-lineno"> 45</tt>  <tt class="py-line">    <tt id="link-4" class="py-name" targets="Variable pyxmpp.jabber.dataforms.Field.xml_element_namespace=pyxmpp.jabber.dataforms.Field-class.html#xml_element_namespace,Variable pyxmpp.jabber.dataforms.Form.xml_element_namespace=pyxmpp.jabber.dataforms.Form-class.html#xml_element_namespace,Variable pyxmpp.jabber.dataforms.Item.xml_element_namespace=pyxmpp.jabber.dataforms.Item-class.html#xml_element_namespace,Variable pyxmpp.jabber.dataforms.Option.xml_element_namespace=pyxmpp.jabber.dataforms.Option-class.html#xml_element_namespace,Variable pyxmpp.jabber.delay.Delay.xml_element_namespace=pyxmpp.jabber.delay.Delay-class.html#xml_element_namespace,Variable pyxmpp.jabber.register.Register.xml_element_namespace=pyxmpp.jabber.register.Register-class.html#xml_element_namespace,Variable pyxmpp.jabber.vcard.VCard.xml_element_namespace=pyxmpp.jabber.vcard.VCard-class.html#xml_element_namespace,Variable pyxmpp.objects.StanzaPayloadObject.xml_element_namespace=pyxmpp.objects.StanzaPayloadObject-class.html#xml_element_namespace,Variable pyxmpp.roster.Roster.xml_element_namespace=pyxmpp.roster.Roster-class.html#xml_element_namespace,Variable pyxmpp.roster.RosterItem.xml_element_namespace=pyxmpp.roster.RosterItem-class.html#xml_element_namespace"><a title="pyxmpp.jabber.dataforms.Field.xml_element_namespace
pyxmpp.jabber.dataforms.Form.xml_element_namespace
pyxmpp.jabber.dataforms.Item.xml_element_namespace
pyxmpp.jabber.dataforms.Option.xml_element_namespace
pyxmpp.jabber.delay.Delay.xml_element_namespace
pyxmpp.jabber.register.Register.xml_element_namespace
pyxmpp.jabber.vcard.VCard.xml_element_namespace
pyxmpp.objects.StanzaPayloadObject.xml_element_namespace
pyxmpp.roster.Roster.xml_element_namespace
pyxmpp.roster.RosterItem.xml_element_namespace" class="py-name" href="#" onclick="return doclink('link-4', 'xml_element_namespace', 'link-4');">xml_element_namespace</a></tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line"> </tt>
<a name="StanzaPayloadObject.as_xml"></a><div id="StanzaPayloadObject.as_xml-def"><a name="L47"></a><tt class="py-lineno"> 47</tt> <a class="py-toggle" href="#" id="StanzaPayloadObject.as_xml-toggle" onclick="return toggle('StanzaPayloadObject.as_xml');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.objects.StanzaPayloadObject-class.html#as_xml">as_xml</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">parent</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt><tt class="py-op">,</tt> <tt class="py-param">doc</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="StanzaPayloadObject.as_xml-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="StanzaPayloadObject.as_xml-expanded"><a name="L48"></a><tt class="py-lineno"> 48</tt>  <tt class="py-line">        <tt class="py-docstring">"""Get the XML representation of `self`.</tt> </tt>
<a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line"><tt class="py-docstring">        New document will be created if no `parent` and no `doc` is given.</tt> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line"><tt class="py-docstring">            - `parent`: the parent for the XML element.</tt> </tt>
<a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line"><tt class="py-docstring">            - `doc`: the document where the element should be created. If not</tt> </tt>
<a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line"><tt class="py-docstring">              given and `parent` is provided then autodetection is attempted.</tt> </tt>
<a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line"><tt class="py-docstring">              If that fails, then `common_doc` is used.</tt> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line"><tt class="py-docstring">            - `parent`: `libxml2.xmlNode`</tt> </tt>
<a name="L59"></a><tt class="py-lineno"> 59</tt>  <tt class="py-line"><tt class="py-docstring">            - `doc`: `libxml2.xmlDoc`</tt> </tt>
<a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line"><tt class="py-docstring">        :return: the new XML element or document created.</tt> </tt>
<a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line"><tt class="py-docstring">        :returntype: `libxml2.xmlNode` or `libxml2.xmlDoc`"""</tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">parent</tt><tt class="py-op">:</tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt id="link-5" class="py-name" targets="Method pyxmpp.xmlextra.StreamReader.doc()=pyxmpp.xmlextra.StreamReader-class.html#doc"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-5', 'doc', 'link-5');">doc</a></tt><tt class="py-op">:</tt> </tt>
<a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line">                <tt class="py-name">n</tt> <tt class="py-op">=</tt> <tt class="py-name">parent</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line">                <tt class="py-keyword">while</tt> <tt class="py-name">n</tt><tt class="py-op">:</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line">                    <tt class="py-keyword">if</tt> <tt class="py-name">n</tt><tt class="py-op">.</tt><tt id="link-6" class="py-name" targets="Variable pyxmpp.jabber.disco.DiscoIdentity.type=pyxmpp.jabber.disco.DiscoIdentity-class.html#type"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-6', 'type', 'link-6');">type</a></tt> <tt class="py-op">==</tt> <tt class="py-string">"xml_document"</tt><tt class="py-op">:</tt> </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line">                        <tt id="link-7" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-7', 'doc', 'link-5');">doc</a></tt> <tt class="py-op">=</tt> <tt class="py-name">n</tt> </tt>
<a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line">                        <tt class="py-keyword">break</tt> </tt>
<a name="L69"></a><tt class="py-lineno"> 69</tt>  <tt class="py-line">                    <tt class="py-name">n</tt> <tt class="py-op">=</tt> <tt class="py-name">n</tt><tt class="py-op">.</tt><tt class="py-name">parent</tt> </tt>
<a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt id="link-8" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-8', 'doc', 'link-5');">doc</a></tt><tt class="py-op">:</tt> </tt>
<a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line">                    <tt id="link-9" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-9', 'doc', 'link-5');">doc</a></tt> <tt class="py-op">=</tt> <tt id="link-10" class="py-name"><a title="pyxmpp.xmlextra.common_doc" class="py-name" href="#" onclick="return doclink('link-10', 'common_doc', 'link-2');">common_doc</a></tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line">            <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line">                <tt id="link-11" class="py-name" targets="Variable pyxmpp.jabber.muccore.MucAdminQuery.ns=pyxmpp.jabber.muccore.MucAdminQuery-class.html#ns,Variable pyxmpp.jabber.muccore.MucUserX.ns=pyxmpp.jabber.muccore.MucUserX-class.html#ns,Variable pyxmpp.jabber.muccore.MucX.ns=pyxmpp.jabber.muccore.MucX-class.html#ns,Variable pyxmpp.jabber.muccore.MucXBase.ns=pyxmpp.jabber.muccore.MucXBase-class.html#ns"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-11', 'ns', 'link-11');">ns</a></tt> <tt class="py-op">=</tt> <tt class="py-name">parent</tt><tt class="py-op">.</tt><tt class="py-name">searchNsByHref</tt><tt class="py-op">(</tt><tt id="link-12" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-12', 'doc', 'link-5');">doc</a></tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-13" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.xml_element_namespace
pyxmpp.jabber.dataforms.Form.xml_element_namespace
pyxmpp.jabber.dataforms.Item.xml_element_namespace
pyxmpp.jabber.dataforms.Option.xml_element_namespace
pyxmpp.jabber.delay.Delay.xml_element_namespace
pyxmpp.jabber.register.Register.xml_element_namespace
pyxmpp.jabber.vcard.VCard.xml_element_namespace
pyxmpp.objects.StanzaPayloadObject.xml_element_namespace
pyxmpp.roster.Roster.xml_element_namespace
pyxmpp.roster.RosterItem.xml_element_namespace" class="py-name" href="#" onclick="return doclink('link-13', 'xml_element_namespace', 'link-4');">xml_element_namespace</a></tt><tt class="py-op">)</tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line">            <tt class="py-keyword">except</tt> <tt class="py-name">libxml2</tt><tt class="py-op">.</tt><tt class="py-name">treeError</tt><tt class="py-op">:</tt> </tt>
<a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line">                <tt id="link-14" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-14', 'ns', 'link-11');">ns</a></tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L76"></a><tt class="py-lineno"> 76</tt>  <tt class="py-line">            <tt class="py-name">xmlnode</tt> <tt class="py-op">=</tt> <tt class="py-name">parent</tt><tt class="py-op">.</tt><tt class="py-name">newChild</tt><tt class="py-op">(</tt><tt id="link-15" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-15', 'ns', 'link-11');">ns</a></tt><tt class="py-op">,</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-16" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.xml_element_name
pyxmpp.jabber.dataforms.Form.xml_element_name
pyxmpp.jabber.dataforms.Item.xml_element_name
pyxmpp.jabber.dataforms.Option.xml_element_name
pyxmpp.jabber.delay.Delay.xml_element_name
pyxmpp.jabber.register.Register.xml_element_name
pyxmpp.jabber.vcard.VCard.xml_element_name
pyxmpp.objects.StanzaPayloadObject.xml_element_name
pyxmpp.roster.Roster.xml_element_name
pyxmpp.roster.RosterItem.xml_element_name" class="py-name" href="#" onclick="return doclink('link-16', 'xml_element_name', 'link-3');">xml_element_name</a></tt><tt class="py-op">,</tt><tt class="py-name">None</tt><tt class="py-op">)</tt> </tt>
<a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt id="link-17" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-17', 'ns', 'link-11');">ns</a></tt><tt class="py-op">:</tt> </tt>
<a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line">                <tt id="link-18" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-18', 'ns', 'link-11');">ns</a></tt> <tt class="py-op">=</tt> <tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">newNs</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-19" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.xml_element_namespace
pyxmpp.jabber.dataforms.Form.xml_element_namespace
pyxmpp.jabber.dataforms.Item.xml_element_namespace
pyxmpp.jabber.dataforms.Option.xml_element_namespace
pyxmpp.jabber.delay.Delay.xml_element_namespace
pyxmpp.jabber.register.Register.xml_element_namespace
pyxmpp.jabber.vcard.VCard.xml_element_namespace
pyxmpp.objects.StanzaPayloadObject.xml_element_namespace
pyxmpp.roster.Roster.xml_element_namespace
pyxmpp.roster.RosterItem.xml_element_namespace" class="py-name" href="#" onclick="return doclink('link-19', 'xml_element_namespace', 'link-4');">xml_element_namespace</a></tt><tt class="py-op">,</tt><tt class="py-name">None</tt><tt class="py-op">)</tt> </tt>
<a name="L79"></a><tt class="py-lineno"> 79</tt>  <tt class="py-line">                <tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">setNs</tt><tt class="py-op">(</tt><tt id="link-20" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-20', 'ns', 'link-11');">ns</a></tt><tt class="py-op">)</tt> </tt>
<a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line">            <tt class="py-name">doc1</tt> <tt class="py-op">=</tt> <tt id="link-21" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-21', 'doc', 'link-5');">doc</a></tt> </tt>
<a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line">        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L82"></a><tt class="py-lineno"> 82</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt id="link-22" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-22', 'doc', 'link-5');">doc</a></tt><tt class="py-op">:</tt> </tt>
<a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line">                <tt class="py-name">doc1</tt> <tt class="py-op">=</tt> <tt id="link-23" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-23', 'doc', 'link-5');">doc</a></tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line">                <tt class="py-name">doc1</tt> <tt class="py-op">=</tt> <tt class="py-name">libxml2</tt><tt class="py-op">.</tt><tt class="py-name">newDoc</tt><tt class="py-op">(</tt><tt class="py-string">"1.0"</tt><tt class="py-op">)</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line">            <tt class="py-name">xmlnode</tt> <tt class="py-op">=</tt> <tt class="py-name">doc1</tt><tt class="py-op">.</tt><tt class="py-name">newChild</tt><tt class="py-op">(</tt><tt class="py-name">None</tt><tt class="py-op">,</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-24" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.xml_element_name
pyxmpp.jabber.dataforms.Form.xml_element_name
pyxmpp.jabber.dataforms.Item.xml_element_name
pyxmpp.jabber.dataforms.Option.xml_element_name
pyxmpp.jabber.delay.Delay.xml_element_name
pyxmpp.jabber.register.Register.xml_element_name
pyxmpp.jabber.vcard.VCard.xml_element_name
pyxmpp.objects.StanzaPayloadObject.xml_element_name
pyxmpp.roster.Roster.xml_element_name
pyxmpp.roster.RosterItem.xml_element_name" class="py-name" href="#" onclick="return doclink('link-24', 'xml_element_name', 'link-3');">xml_element_name</a></tt><tt class="py-op">,</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt> </tt>
<a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line">            <tt id="link-25" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-25', 'ns', 'link-11');">ns</a></tt> <tt class="py-op">=</tt> <tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">newNs</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-26" class="py-name"><a title="pyxmpp.jabber.dataforms.Field.xml_element_namespace
pyxmpp.jabber.dataforms.Form.xml_element_namespace
pyxmpp.jabber.dataforms.Item.xml_element_namespace
pyxmpp.jabber.dataforms.Option.xml_element_namespace
pyxmpp.jabber.delay.Delay.xml_element_namespace
pyxmpp.jabber.register.Register.xml_element_namespace
pyxmpp.jabber.vcard.VCard.xml_element_namespace
pyxmpp.objects.StanzaPayloadObject.xml_element_namespace
pyxmpp.roster.Roster.xml_element_namespace
pyxmpp.roster.RosterItem.xml_element_namespace" class="py-name" href="#" onclick="return doclink('link-26', 'xml_element_namespace', 'link-4');">xml_element_namespace</a></tt><tt class="py-op">,</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt> </tt>
<a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line">            <tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">setNs</tt><tt class="py-op">(</tt><tt id="link-27" class="py-name"><a title="pyxmpp.jabber.muccore.MucAdminQuery.ns
pyxmpp.jabber.muccore.MucUserX.ns
pyxmpp.jabber.muccore.MucX.ns
pyxmpp.jabber.muccore.MucXBase.ns" class="py-name" href="#" onclick="return doclink('link-27', 'ns', 'link-11');">ns</a></tt><tt class="py-op">)</tt> </tt>
<a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line"> </tt>
<a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-28" class="py-name" targets="Method pyxmpp.jabber.dataforms.Field.complete_xml_element()=pyxmpp.jabber.dataforms.Field-class.html#complete_xml_element,Method pyxmpp.jabber.dataforms.Form.complete_xml_element()=pyxmpp.jabber.dataforms.Form-class.html#complete_xml_element,Method pyxmpp.jabber.dataforms.Item.complete_xml_element()=pyxmpp.jabber.dataforms.Item-class.html#complete_xml_element,Method pyxmpp.jabber.dataforms.Option.complete_xml_element()=pyxmpp.jabber.dataforms.Option-class.html#complete_xml_element,Method pyxmpp.jabber.delay.Delay.complete_xml_element()=pyxmpp.jabber.delay.Delay-class.html#complete_xml_element,Method pyxmpp.jabber.register.Register.complete_xml_element()=pyxmpp.jabber.register.Register-class.html#complete_xml_element,Method pyxmpp.jabber.vcard.VCard.complete_xml_element()=pyxmpp.jabber.vcard.VCard-class.html#complete_xml_element,Method pyxmpp.objects.StanzaPayloadObject.complete_xml_element()=pyxmpp.objects.StanzaPayloadObject-class.html#complete_xml_element,Method pyxmpp.roster.Roster.complete_xml_element()=pyxmpp.roster.Roster-class.html#complete_xml_element,Method pyxmpp.roster.RosterItem.complete_xml_element()=pyxmpp.roster.RosterItem-class.html#complete_xml_element"><a title="pyxmpp.jabber.dataforms.Field.complete_xml_element
pyxmpp.jabber.dataforms.Form.complete_xml_element
pyxmpp.jabber.dataforms.Item.complete_xml_element
pyxmpp.jabber.dataforms.Option.complete_xml_element
pyxmpp.jabber.delay.Delay.complete_xml_element
pyxmpp.jabber.register.Register.complete_xml_element
pyxmpp.jabber.vcard.VCard.complete_xml_element
pyxmpp.objects.StanzaPayloadObject.complete_xml_element
pyxmpp.roster.Roster.complete_xml_element
pyxmpp.roster.RosterItem.complete_xml_element" class="py-name" href="#" onclick="return doclink('link-28', 'complete_xml_element', 'link-28');">complete_xml_element</a></tt><tt class="py-op">(</tt><tt class="py-name">xmlnode</tt><tt class="py-op">,</tt> <tt class="py-name">doc1</tt><tt class="py-op">)</tt> </tt>
<a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line"> </tt>
<a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt id="link-29" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-29', 'doc', 'link-5');">doc</a></tt> <tt class="py-keyword">or</tt> <tt class="py-name">parent</tt><tt class="py-op">:</tt> </tt>
<a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">xmlnode</tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line">        <tt class="py-name">doc1</tt><tt class="py-op">.</tt><tt class="py-name">setRootElement</tt><tt class="py-op">(</tt><tt class="py-name">xmlnode</tt><tt class="py-op">)</tt> </tt>
<a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">doc1</tt> </tt>
</div><a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line"> </tt>
<a name="StanzaPayloadObject.complete_xml_element"></a><div id="StanzaPayloadObject.complete_xml_element-def"><a name="L97"></a><tt class="py-lineno"> 97</tt> <a class="py-toggle" href="#" id="StanzaPayloadObject.complete_xml_element-toggle" onclick="return toggle('StanzaPayloadObject.complete_xml_element');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.objects.StanzaPayloadObject-class.html#complete_xml_element">complete_xml_element</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">xmlnode</tt><tt class="py-op">,</tt> <tt class="py-param">doc</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="StanzaPayloadObject.complete_xml_element-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="StanzaPayloadObject.complete_xml_element-expanded"><a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line">        <tt class="py-docstring">"""Complete the XML node with `self` content.</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L100"></a><tt class="py-lineno">100</tt>  <tt class="py-line"><tt class="py-docstring">        Should be overriden in classes derived from `StanzaPayloadObject`.</tt> </tt>
<a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line"><tt class="py-docstring">            - `xmlnode`: XML node with the element being built. It has already</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line"><tt class="py-docstring">              right name and namespace, but no attributes or content.</tt> </tt>
<a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line"><tt class="py-docstring">            - `doc`: document to which the element belongs.</tt> </tt>
<a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line"><tt class="py-docstring">            - `xmlnode`: `libxml2.xmlNode`</tt> </tt>
<a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line"><tt class="py-docstring">            - `doc`: `libxml2.xmlDoc`"""</tt> </tt>
<a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line">        <tt class="py-keyword">pass</tt> </tt>
</div></div><a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line"> </tt>
<a name="StanzaPayloadWrapperObject"></a><div id="StanzaPayloadWrapperObject-def"><a name="L111"></a><tt class="py-lineno">111</tt> <a class="py-toggle" href="#" id="StanzaPayloadWrapperObject-toggle" onclick="return toggle('StanzaPayloadWrapperObject');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyxmpp.objects.StanzaPayloadWrapperObject-class.html">StanzaPayloadWrapperObject</a><tt class="py-op">(</tt><tt class="py-base-class">object</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="StanzaPayloadWrapperObject-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="StanzaPayloadWrapperObject-expanded"><a name="L112"></a><tt class="py-lineno">112</tt>  <tt class="py-line">    <tt class="py-docstring">"""Base class for objects that may be used as XMPP stanza payload and maintain</tt> </tt>
<a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line"><tt class="py-docstring">    an internal XML representation of self.</tt> </tt>
<a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L115"></a><tt class="py-lineno">115</tt>  <tt class="py-line"><tt class="py-docstring">    Provides `as_xml` method. Objects of derived classes must have the `xmlnode` attribute.</tt> </tt>
<a name="L116"></a><tt class="py-lineno">116</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line"><tt class="py-docstring">    Please note that not all classes derived from `StanzaPayloadWrapperObject` should be</tt> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line"><tt class="py-docstring">    used directly as stanza payload. Some of them are parts of higher level objects.</tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line"><tt class="py-docstring">    :Ivariables:</tt> </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line"><tt class="py-docstring">        - `xmlnode`: XML node of the object.</tt> </tt>
<a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line"><tt class="py-docstring">    :Types:</tt> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line"><tt class="py-docstring">        - `xmlnode`: `libxml2.xmlNode`</tt> </tt>
<a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line"><tt class="py-docstring">    """</tt> </tt>
<a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line"> </tt>
<a name="StanzaPayloadWrapperObject.as_xml"></a><div id="StanzaPayloadWrapperObject.as_xml-def"><a name="L126"></a><tt class="py-lineno">126</tt> <a class="py-toggle" href="#" id="StanzaPayloadWrapperObject.as_xml-toggle" onclick="return toggle('StanzaPayloadWrapperObject.as_xml');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyxmpp.objects.StanzaPayloadWrapperObject-class.html#as_xml">as_xml</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">parent</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt><tt class="py-op">,</tt> <tt class="py-param">doc</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="StanzaPayloadWrapperObject.as_xml-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="StanzaPayloadWrapperObject.as_xml-expanded"><a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line">        <tt class="py-docstring">"""Get the XML representation of `self`.</tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line"><tt class="py-docstring">        New document will be created if no `parent` and no `doc` is given.</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line"><tt class="py-docstring">        :Parameters:</tt> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line"><tt class="py-docstring">            - `parent`: the parent for the XML element.</tt> </tt>
<a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line"><tt class="py-docstring">            - `doc`: the document where the element should be created. If not</tt> </tt>
<a name="L134"></a><tt class="py-lineno">134</tt>  <tt class="py-line"><tt class="py-docstring">              given and `parent` is provided then autodetection is attempted.</tt> </tt>
<a name="L135"></a><tt class="py-lineno">135</tt>  <tt class="py-line"><tt class="py-docstring">              If that fails, then `common_doc` is used.</tt> </tt>
<a name="L136"></a><tt class="py-lineno">136</tt>  <tt class="py-line"><tt class="py-docstring">        :Types:</tt> </tt>
<a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line"><tt class="py-docstring">            - `parent`: `libxml2.xmlNode`</tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line"><tt class="py-docstring">            - `doc`: `libxml2.xmlDoc`</tt> </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line"><tt class="py-docstring"></tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line"><tt class="py-docstring">        :return: the new XML element (copy of `self.xmlnode`) or document</tt> </tt>
<a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line"><tt class="py-docstring">            created (containg the copy as the root element).</tt> </tt>
<a name="L142"></a><tt class="py-lineno">142</tt>  <tt class="py-line"><tt class="py-docstring">        :returntype: `libxml2.xmlNode` or `libxml2.xmlDoc`"""</tt> </tt>
<a name="L143"></a><tt class="py-lineno">143</tt>  <tt class="py-line">        <tt class="py-keyword">if</tt> <tt class="py-name">parent</tt><tt class="py-op">:</tt> </tt>
<a name="L144"></a><tt class="py-lineno">144</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt id="link-30" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-30', 'doc', 'link-5');">doc</a></tt><tt class="py-op">:</tt> </tt>
<a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line">                <tt class="py-name">n</tt> <tt class="py-op">=</tt> <tt class="py-name">parent</tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line">                <tt class="py-keyword">while</tt> <tt class="py-name">n</tt><tt class="py-op">:</tt> </tt>
<a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line">                    <tt class="py-keyword">if</tt> <tt class="py-name">n</tt><tt class="py-op">.</tt><tt id="link-31" class="py-name"><a title="pyxmpp.jabber.disco.DiscoIdentity.type" class="py-name" href="#" onclick="return doclink('link-31', 'type', 'link-6');">type</a></tt> <tt class="py-op">==</tt> <tt class="py-string">"xml_document"</tt><tt class="py-op">:</tt> </tt>
<a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line">                        <tt id="link-32" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-32', 'doc', 'link-5');">doc</a></tt> <tt class="py-op">=</tt> <tt class="py-name">n</tt> </tt>
<a name="L149"></a><tt class="py-lineno">149</tt>  <tt class="py-line">                        <tt class="py-keyword">break</tt> </tt>
<a name="L150"></a><tt class="py-lineno">150</tt>  <tt class="py-line">                    <tt class="py-name">n</tt> <tt class="py-op">=</tt> <tt class="py-name">n</tt><tt class="py-op">.</tt><tt class="py-name">parent</tt> </tt>
<a name="L151"></a><tt class="py-lineno">151</tt>  <tt class="py-line">                <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt id="link-33" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-33', 'doc', 'link-5');">doc</a></tt><tt class="py-op">:</tt> </tt>
<a name="L152"></a><tt class="py-lineno">152</tt>  <tt class="py-line">                    <tt id="link-34" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-34', 'doc', 'link-5');">doc</a></tt> <tt class="py-op">=</tt> <tt id="link-35" class="py-name"><a title="pyxmpp.xmlextra.common_doc" class="py-name" href="#" onclick="return doclink('link-35', 'common_doc', 'link-2');">common_doc</a></tt> </tt>
<a name="L153"></a><tt class="py-lineno">153</tt>  <tt class="py-line">            <tt id="link-36" class="py-name" targets="Method pyxmpp.iq.Iq.copy()=pyxmpp.iq.Iq-class.html#copy,Method pyxmpp.jabber.dataforms.Form.copy()=pyxmpp.jabber.dataforms.Form-class.html#copy,Method pyxmpp.jabber.muccore.MucIq.copy()=pyxmpp.jabber.muccore.MucIq-class.html#copy,Method pyxmpp.jabber.muccore.MucPresence.copy()=pyxmpp.jabber.muccore.MucPresence-class.html#copy,Method pyxmpp.message.Message.copy()=pyxmpp.message.Message-class.html#copy,Method pyxmpp.presence.Presence.copy()=pyxmpp.presence.Presence-class.html#copy,Method pyxmpp.stanza.Stanza.copy()=pyxmpp.stanza.Stanza-class.html#copy"><a title="pyxmpp.iq.Iq.copy
pyxmpp.jabber.dataforms.Form.copy
pyxmpp.jabber.muccore.MucIq.copy
pyxmpp.jabber.muccore.MucPresence.copy
pyxmpp.message.Message.copy
pyxmpp.presence.Presence.copy
pyxmpp.stanza.Stanza.copy" class="py-name" href="#" onclick="return doclink('link-36', 'copy', 'link-36');">copy</a></tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">docCopyNode</tt><tt class="py-op">(</tt><tt id="link-37" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-37', 'doc', 'link-5');">doc</a></tt><tt class="py-op">,</tt><tt class="py-name">True</tt><tt class="py-op">)</tt> </tt>
<a name="L154"></a><tt class="py-lineno">154</tt>  <tt class="py-line">            <tt class="py-name">parent</tt><tt class="py-op">.</tt><tt class="py-name">addChild</tt><tt class="py-op">(</tt><tt id="link-38" class="py-name"><a title="pyxmpp.iq.Iq.copy
pyxmpp.jabber.dataforms.Form.copy
pyxmpp.jabber.muccore.MucIq.copy
pyxmpp.jabber.muccore.MucPresence.copy
pyxmpp.message.Message.copy
pyxmpp.presence.Presence.copy
pyxmpp.stanza.Stanza.copy" class="py-name" href="#" onclick="return doclink('link-38', 'copy', 'link-36');">copy</a></tt><tt class="py-op">)</tt> </tt>
<a name="L155"></a><tt class="py-lineno">155</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt id="link-39" class="py-name"><a title="pyxmpp.iq.Iq.copy
pyxmpp.jabber.dataforms.Form.copy
pyxmpp.jabber.muccore.MucIq.copy
pyxmpp.jabber.muccore.MucPresence.copy
pyxmpp.message.Message.copy
pyxmpp.presence.Presence.copy
pyxmpp.stanza.Stanza.copy" class="py-name" href="#" onclick="return doclink('link-39', 'copy', 'link-36');">copy</a></tt> </tt>
<a name="L156"></a><tt class="py-lineno">156</tt>  <tt class="py-line">        <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L157"></a><tt class="py-lineno">157</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt class="py-keyword">not</tt> <tt id="link-40" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-40', 'doc', 'link-5');">doc</a></tt><tt class="py-op">:</tt> </tt>
<a name="L158"></a><tt class="py-lineno">158</tt>  <tt class="py-line">                <tt class="py-name">doc1</tt><tt class="py-op">=</tt><tt class="py-name">libxml2</tt><tt class="py-op">.</tt><tt class="py-name">newDoc</tt><tt class="py-op">(</tt><tt class="py-string">"1.0"</tt><tt class="py-op">)</tt> </tt>
<a name="L159"></a><tt class="py-lineno">159</tt>  <tt class="py-line">            <tt class="py-keyword">else</tt><tt class="py-op">:</tt> </tt>
<a name="L160"></a><tt class="py-lineno">160</tt>  <tt class="py-line">                <tt class="py-name">doc1</tt><tt class="py-op">=</tt><tt id="link-41" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-41', 'doc', 'link-5');">doc</a></tt> </tt>
<a name="L161"></a><tt class="py-lineno">161</tt>  <tt class="py-line">            <tt class="py-name">xmlnode</tt><tt class="py-op">=</tt><tt class="py-name">doc1</tt><tt class="py-op">.</tt><tt class="py-name">addChild</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">xmlnode</tt><tt class="py-op">.</tt><tt class="py-name">docCopyNode</tt><tt class="py-op">(</tt><tt id="link-42" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-42', 'doc', 'link-5');">doc</a></tt><tt class="py-op">,</tt><tt class="py-name">True</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L162"></a><tt class="py-lineno">162</tt>  <tt class="py-line">            <tt class="py-name">doc1</tt><tt class="py-op">.</tt><tt class="py-name">setRootElement</tt><tt class="py-op">(</tt><tt class="py-name">xmlnode</tt><tt class="py-op">)</tt> </tt>
<a name="L163"></a><tt class="py-lineno">163</tt>  <tt class="py-line">            <tt class="py-keyword">if</tt> <tt id="link-43" class="py-name"><a title="pyxmpp.xmlextra.StreamReader.doc" class="py-name" href="#" onclick="return doclink('link-43', 'doc', 'link-5');">doc</a></tt><tt class="py-op">:</tt> </tt>
<a name="L164"></a><tt class="py-lineno">164</tt>  <tt class="py-line">                <tt class="py-keyword">return</tt> <tt class="py-name">xmlnode</tt> </tt>
<a name="L165"></a><tt class="py-lineno">165</tt>  <tt class="py-line">            <tt class="py-keyword">return</tt> <tt class="py-name">doc1</tt> </tt>
</div></div><a name="L166"></a><tt class="py-lineno">166</tt>  <tt class="py-line"> </tt>
<a name="L167"></a><tt class="py-lineno">167</tt>  <tt class="py-line"><tt class="py-comment"># vi: sts=4 et sw=4</tt> </tt>
<a name="L168"></a><tt class="py-lineno">168</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:08 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
